module cirrus.c.windows.clr;

private import cirrus.c.windows.com;

pragma(lib, "mscoree.lib");

extern(Windows):

typedef int Handle = 0;

enum : uint {
  STARTUP_CONCURRENT_GC = 0x1,
  STARTUP_LOADER_OPTIMIZATION_MASK = 0x3 << 1,
  STARTUP_LOADER_OPTIMIZATION_SINGLE_DOMAIN = 0x1 << 1,
  STARTUP_LOADER_OPTIMIZATION_MULTI_DOMAIN = 0x2 << 1,
  STARTUP_LOADER_OPTIMIZATION_MULTI_DOMAIN_HOST = 0x3 << 1,
  STARTUP_LOADER_SAFEMODE = 0x10,
  STARTUP_LOADER_SETPREFERENCE = 0x100
}

enum AssemblyNameFlags {
  None,
  FullOriginator
}

enum AssemblyBuilderAccess {
  Run = 1,
  Save,
  RunAndSave
}

enum BindingFlags {
  DefaultLookup = 28,
  LookupAll = 60,
  ConstructorLookupAll = 52,
  Default = 196636,
  ConstructorDefault = 196660,
  IgnoreCase = 1,
  DeclaredOnly = 2,
  Instance = 4,
  Static = 8,
  Public = 16,
  NonPublic = 32,
  FlattenHierarchy = 64,
  InvokeMethod = 256,
  CreateInstance = 512,
  GetField = 1024,
  SetField = 2048,
  GetProperty = 4096,
  SetProperty = 8192,
  PutDispProperty = 16384,
  PutRefDispProperty = 32768,
  DefaultBinding = 65536,
  DefaultChangeType = 131072,
  ExactBinding = 262144,
  ExactChangeType = 524288,
  ExactFull = 786432,
  BinderBinding = 1048576,
  BinderChangeType = 2097152,
  BinderFull = 3145728,
  DefaultValueBinding = 4194304,
  DefaultValueChangeType = 8388608,
  DefaultValueFull = 12582912,
  IgnoreReturn = 16777216,
  CallNonVirt = 33554432
}

enum PrincipalPolicy {
  NoPrincipal,
  UnauthenticatedPrincipal,
  WindowsPrincipal,
  MTSPrincipal
}

enum StreamingContextStates {
  CrossProcess = 1,
  CrossMachine = 2,
  File = 4,
  Persistence = 8,
  Remoting = 16,
  Other = 32,
  Clone = 64,
  All = 127
}

enum ProcessorID {
  INTEL_386 = 386,
  INTEL_486 = 486,
  INTEL_PENTIUM = 586,
  MIPS_R4000 = 4000,
  ALPHA_21064 = 21064,
  PPC_601 = 601,
  PPC_603 = 603,
  PPC_604 = 604,
  PPC_620 = 620,
  HITACHI_SH3 = 10003,
  HITACHI_SH3E = 10004,
  HITACHI_SH4 = 10005,
  MOTOROLA_821 = 821,
  SHx_SH3 = 103,
  SHx_SH4 = 104,
  STRONGARM = 2577,
  ARM720 = 1824,
  ARM820 = 2080,
  ARM920 = 2336,
  ARM_7TDMI = 70001
}

enum AssemblyHashAlgorithm {
  None = 0,
  MD5 = 32771,
  SHA1 = 32772
}

enum AssemblyVersionCompatibility {
  SameMachine = 1,
  SameProcess,
  SameDomain
}

// mscoree

interface IGCThreadControl : IUnknown {
  static GUID IID = { 0xF31D1788, 0xC397, 0x4725, 0x87, 0xA5, 0x6A, 0xF3, 0x47, 0x2C, 0x27, 0x91 };
  int ThreadIsBlockingForSuspension();
  int SuspensionStarting();
  int SuspensionEnding(uint Generation);
}

interface IGCHostControl : IUnknown {
  static GUID IID = { 0x5513D564, 0x8374, 0x4cb9, 0xAE, 0xD9, 0x00, 0x83, 0xF4, 0x16, 0x0A, 0x1D };
  int RequestVirtualMemLimit(size_t sztMaxVirtualMemMB, inout size_t psztNewMaxVirtualMemMB);
}

interface IDebuggerThreadControl : IUnknown {
  static GUID IID = { 0x23D86786, 0x0BB5, 0x4774, 0x8F, 0xB5, 0xE3, 0x52, 0x2A, 0xDD, 0x62, 0x46 };
  int ThreadIsBlockingForDebugger();
  int ReleaseAllRuntimeThreads();
  int StartBlockingForDebugger(uint dwUnused);
}

interface ICorConfiguration : IUnknown {
  static GUID IID = { 0x5C2B07A5, 0x1E98, 0x11d3, 0x87, 0x2F, 0x00, 0xC0, 0x4F, 0x79, 0xED, 0x0D };
  int SetGCThreadControl(IGCThreadControl pGCThreadControl);
  int SetGCHostControl(IGCHostControl pGCHostControl);
  int SetDebuggerThreadControl(IDebuggerThreadControl pDebuggerThreadControl);
  int AddDebuggerSpecialThread(uint dwSpecialThreadId);
}

interface ICorRuntimeHost : IUnknown {
  static GUID IID = { 0xCB2F6722, 0xAB3A, 0x11d2, 0x9C, 0x40, 0x00, 0xC0, 0x4F, 0xA3, 0x0A, 0x3E };
  int CreateLogicalThreadState();
  int DeleteLogicalThreadState();
  int SwitchInLogicalThreadState(uint* pFiberCookie);
  int SwitchOutLogicalThreadState(out uint* pFiberCookie);
  int LocksHeldByLogicalThread(out uint pCount);
  int MapFile(Handle hFile, out Handle hMapAddress);
  int GetConfiguration(out ICorConfiguration pConfiguration);
  int Start();
  int Stop();
  int CreateDomain(wchar* pwzFriendlyName, IUnknown pIdentityArray, out IUnknown pAppDomain);
  int GetDefaultDomain(out IUnknown pAppDomain);
  int EnumDomains(void* hEnum);
  int NextDomain(void* hEnum, out IUnknown ppAppDomain);
  int CloseEnum(void* hEnum);
  int CreateDomainEx(wchar* pwzFriendlyName, IUnknown pSetup, IUnknown pEvidence, out IUnknown pAppDomain);
  int CreateDomainSetup(out IUnknown pAppDomainSetup);
  int CreateEvidence(out IUnknown pEvidence);
  int UnloadDomain(IUnknown pAppDomain);
  int CurrentDomain(out IUnknown pAppDomain);
}

// mscorlib

struct StreamingContext {
  IUnknown additionalContext;
  StreamingContextStates state;
}

interface IIdentity : IDispatch {
  static GUID IID = { 0xF4205A87, 0x4D46, 0x303D, 0xB1, 0xD9, 0x5A, 0x99, 0xF7, 0xC9, 0x0D, 0x30 };
  int Name(out wchar* pRetVal);
  int AuthenticationType(out wchar* pRetVal);
  int IsAuthenticated(out short pRetVal);
}

interface IPrincipal : IDispatch {
  static GUID IID = { 0x4283CA6C, 0xD291, 0x3481, 0x83, 0xC9, 0x95, 0x54, 0x48, 0x1F, 0xE8, 0x88 };
  int Identity(out IIdentity pRetVal);
  int IsInRole(wchar* role, out short pRetVal);
}

interface _Object : IDispatch {
  static GUID IID = { 0x65074F7F, 0x63C0, 0x304E, 0xAF, 0x0A, 0xD5, 0x17, 0x41, 0xCB, 0x4A, 0x8D };
  int ToString(out wchar* pRetVal);
  int Equals(VARIANT obj, out short pRetVal);
  int GetHashCode(out int pRetVal);
  int GetType(out _Type pRetVal);
}

interface _ObjectHandle : _Object {
  static GUID IID = { 0xEA675B47, 0x64E0, 0x3B5F, 0x9B, 0xE7, 0xF7, 0xDC, 0x29, 0x90, 0x73, 0x0D };
  int InitializeLifetimeService(out VARIANT pRetVal);
  int GetLifetimeService(out VARIANT pRetVal);
  int Unwrap(out VARIANT pRetVal);
}

interface _AssemblyBuilder : _Object {
}

interface _Evidence : _Object {
}

interface _PermissionSet : _Object {
}

interface _PolicyLevel : _Object {
}

interface _CrossAppDomainDelegate : _Object {
}

interface _Binder : _Object {
}

interface _CultureInfo : _Object {
}

interface _WaitHandle : _Object {
}

interface _MethodInfo : _Object {
}

interface _Version : _Object {
}

interface _Assembly : _Object {
}

interface _AppDomain : _Object {
  static GUID IID = { 0x05F696DC, 0x2B29, 0x3663, 0xAD, 0x8B, 0xC4, 0x38, 0x9C, 0xF2, 0xA7, 0x13 };
  int InitializeLifetimeService(out VARIANT pRetVal);
  int GetLifetimeService(out VARIANT pRetVal);
  int Evidence(out _Evidence pRetVal);
  int add_DomainUnload(_EventHandler value);
  int remove_DomainUnload(_EventHandler value);
  int add_AssemblyLoad(_AssemblyLoadEventHandler value);
  int remove_AssemblyLoad(_AssemblyLoadEventHandler value);
  int add_ProcessExit(_EventHandler value);
  int remove_ProcessExit(_EventHandler value);
  int add_TypeResolve(_ResolveEventHandler value);
  int remove_TypeResolve(_ResolveEventHandler value);
  int add_ResourceResolve(_ResolveEventHandler value);
  int remove_ResourceResolve(_ResolveEventHandler value);
  int add_AssemblyResolve(_ResolveEventHandler value);
  int remove_AssemblyResolve(_ResolveEventHandler value);
  int add_UnhandledException(_UnhandledExceptionEventHandler value);
  int remove_UnhandledException(_UnhandledExceptionEventHandler value);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, out _AssemblyBuilder pRetVal);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, wchar* dir, out _AssemblyBuilder pRetVal);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, _Evidence Evidence, out _AssemblyBuilder pRetVal);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, _PermissionSet requiredPermissions, _PermissionSet optionalPermissions, _PermissionSet refusedPermissions, out _AssemblyBuilder pRetVal);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, wchar* dir, _Evidence Evidence, out _AssemblyBuilder pRetVal);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, wchar* dir, _PermissionSet requiredPermissions, _PermissionSet optionalPermissions, _PermissionSet refusedPermissions, out _AssemblyBuilder pRetVal);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, _Evidence Evidence, _PermissionSet requiredPermissions, _PermissionSet optionalPermissions, _PermissionSet refusedPermissions, out _AssemblyBuilder pRetVal);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, wchar* dir, _Evidence Evidence, _PermissionSet requiredPermissions, _PermissionSet optionalPermissions, _PermissionSet refusedPermissions, out _AssemblyBuilder pRetVal);
  int DefineDynamicAssembly(_AssemblyName name, AssemblyBuilderAccess access, wchar* dir, _Evidence Evidence, _PermissionSet requiredPermissions, _PermissionSet optionalPermissions, _PermissionSet refusedPermissions, short IsSynchronized, out _AssemblyBuilder pRetVal);
  int CreateInstance(wchar* AssemblyName, wchar* typeName, out _ObjectHandle pRetVal);
  int CreateInstanceFrom(wchar* AssemblyName, wchar* typeName, out _ObjectHandle pRetVal);
  int CreateInstance(wchar* AssemblyName, wchar* typeName, SAFEARRAY* activationAttributes, out _ObjectHandle pRetVal);
  int CreateInstanceFrom(wchar* AssemblyName, wchar* typeName, SAFEARRAY* activationAttributes, out _ObjectHandle pRetVal);
  int CreateInstance(wchar* AssemblyName, wchar* typeName, short ignoreCase, BindingFlags bindingAttr, _Binder Binder, SAFEARRAY* args, _CultureInfo culture, SAFEARRAY* activationAttributes, _Evidence securityAttributes, out _ObjectHandle pRetVal);
  int CreateInstanceFrom(wchar* AssemblyName, wchar* typeName, short ignoreCase, BindingFlags bindingAttr, _Binder Binder, SAFEARRAY* args, _CultureInfo culture, SAFEARRAY* activationAttributes, _Evidence securityAttributes, out _ObjectHandle pRetVal);
  int Load(_AssemblyName assemblyRef, out _Assembly pRetVal);
  int Load(wchar* assemblyString, out _Assembly pRetVal);
  int Load(SAFEARRAY* rawAssembly, out _Assembly pRetVal);
  int Load(SAFEARRAY* rawAssembly, SAFEARRAY* rawSymbolStore, out _Assembly pRetVal);
  int Load(SAFEARRAY* rawAssembly, SAFEARRAY* rawSymbolStore, _Evidence securityEvidence, out _Assembly pRetVal);
  int Load(_AssemblyName assemblyRef, _Evidence assemblySecurity, out _Assembly pRetVal);
  int Load(wchar* assemblyString, _Evidence assemblySecurity, out _Assembly pRetVal);
  int ExecuteAssembly(wchar* assemblyFile, _Evidence assemblySecurity, out int pRetVal);
  int ExecuteAssembly(wchar* assemblyFile, out int pRetVal);
  int ExecuteAssembly(wchar* assemblyFile, _Evidence assemblySecurity, SAFEARRAY* args, out int pRetVal);
  int FriendlyName(out wchar* pRetVal);
  int BaseDirectory(out wchar* pRetVal);
  int RelativeSearchPath(out wchar* pRetVal);
  int ShadowCopyFiles(out short pRetVal);
  int GetAssemblies(SAFEARRAY* pRetVal);
  int AppendPrivatePath(wchar* Path);
  int ClearPrivatePath();
  int SetShadowCopyPath(wchar* s);
  int ClearShadowCopyPath();
  int SetCachePath(wchar* s);
  int SetData(wchar* name, VARIANT data);
  int GetData(wchar* name, out VARIANT data);
  int SetAppDomainPolicy(_PolicyLevel domainPolicy);
  int SetThreadPrincipal(IPrincipal principal);
  int SetPrincipalPolicy(PrincipalPolicy policy);
  int DoCallBack(_CrossAppDomainDelegate theDelegate);
  int DynamicDirectory(out wchar* pRetVal);
}

interface IAsyncResult : IDispatch {
  int IsCompleted(out short pRetVal);
  int AsyncWaitHandle(out _WaitHandle pRetVal);
  int AsyncObject(out VARIANT pRetVal);
  int AsyncState(out VARIANT pRetVal);
  int CompletedSynchronously(out short pRetVal);
}

interface _SerializationInfo : _Object {
}

interface _EventArgs : _Object {
}

interface _EventHandler : _Object {
}

interface _AssemblyLoadEventHandler : _EventHandler {
}

interface _ResolveEventHandler : _EventHandler {
}

interface _UnhandledExceptionEventHandler : _EventHandler {
}

interface _AsyncCallback : _EventHandler {
}

interface _StrongNameKeyPair : _Object {
}

interface _AssemblyName : _Object {
}

interface _Type : _Object {
}

interface IComparer : IDispatch {
}

interface ICloneable : IDispatch {
  static GUID IID = { 0x0CB251A7, 0x3AB3, 0x3B5C, 0xA0, 0xB8, 0x9D, 0xDF, 0x88, 0x82, 0x4B, 0x85 };
  int Clone(out VARIANT pRetVal);
}

interface IEnumerator : IDispatch {
  static GUID IID = { 0x496B0ABF, 0xCDEE, 0x11D3, 0x88, 0xE8, 0x00, 0x90, 0x27, 0x54, 0xC4, 0x3A };
  int MoveNext(out VARIANT pRetVal);
  int Current(out VARIANT pRetVal);
  int Reset();
}

interface IList : IDispatch {
  static GUID IID = { 0x7BCFA00F, 0xF764, 0x3113, 0x91, 0x40, 0x3B, 0xBD, 0x12, 0x7A, 0x96, 0xBB };
  int get_Item(int index, out VARIANT pRetVal);
  int put_Item(int index, VARIANT value);
  int Add(VARIANT value, out int pRetVal);
  int Contains(VARIANT value, out short pRetVal);
  int Clear();
  int IsReadOnly(out short pRetVal);
  int IsFixedSize(out short pRetVal);
  int IndexOf(VARIANT value, out int pRetVal);
  int Insert(int index, VARIANT value);
  int Remove(VARIANT value);
  int RemoveAt(int index);
}

interface ICollection : IDispatch {
  static GUID IID = { 0xDE8DB6F8, 0xD101, 0x3A92, 0x8D, 0x1C, 0xE7, 0x2E, 0x5F, 0x10, 0xE9, 0x92 };
  int CopyTo(_Array Array, int index);
  int Count(out int pRetVal);
  int SyncRoot(out VARIANT pRetVal);
  int IsSynchronized(out short pRetVal);
}

interface _Array : _Object {
  static GUID IID = { 0x2B67CECE, 0x71C3, 0x36A9, 0xA1, 0x36, 0x92, 0x5C, 0xCC, 0x19, 0x35, 0xA8 };
}

interface _ArrayList : _Object {
  static GUID IID = { 0x401F89CB, 0xC127, 0x3041, 0x82, 0xFD, 0xB6, 0x70, 0x35, 0x39, 0x5C, 0x56 };
}

abstract final class CorRuntimeHost {
  static GUID IID = { 0xCB2F6723, 0xAB3A, 0x11d2, 0x9C, 0x40, 0x00, 0xC0, 0x4F, 0xA3, 0x0A, 0x3E };
  mixin CoClass!(ICorRuntimeHost);
}

abstract final class Array {
  static GUID IID = { 0x200FB91C, 0x815D, 0x39E0, 0x9E, 0x07, 0x0E, 0x1B, 0xDB, 0x2E, 0xD4, 0x7B };
  mixin CoClass!(_Array);
}

abstract final class ArrayList {
  static GUID IID = { 0x6896B49D, 0x7AFB, 0x34DC, 0x93, 0x4E, 0x5A, 0xDD, 0x38, 0xEE, 0xEE, 0x39 };
  mixin CoClass!(_ArrayList);
}

int CorBindToRuntimeEx(wchar* pwszVersion, wchar* pwszBuildFavor, uint flags, inout GUID rclsid, inout GUID riid, void** ppv);