module cirrus.clrtest;

import cirrus.c.windows.com,
  cirrus.c.windows.clr;
import std.stdio;

int main() {
  CoInitialize(null);

  // Create an instance of System.Collections.ArrayList
  _ArrayList arrayList = ArrayList.createObject!(_ArrayList);
  if (arrayList !is null) {
    wchar* bstr;
    // Call System.Object.ToString
    arrayList.ToString(bstr);
    wprintf("arrayList.ToString()\n\t=> %s\n\n", bstr);
    SysFreeString(bstr);

    // Query our object for the System.Collections.IList interface
    IList list = com_cast!(IList)(arrayList);
    // Then for System.Collections.ICollection
    ICollection collection = com_cast!(ICollection)(arrayList);

    if (list !is null && collection !is null) {
      int index;
      // Add an int
      int hr = list.Add(VARIANT(12345), index);

      if (hr == S_OK) {
        int count;
        hr = collection.Count(count);
        if (hr == S_OK)
          wprintf("collection.Count\n\t=> %d\n\n", count);

        VARIANT v;
        // Get the item we just added
        hr = list.get_Item(index, v);
        if (hr == S_OK)
          wprintf("list[%i]\n\t=> %d\n\n", index, v.lVal);
      }

      // We must use SysAllocString to create our string
      VARIANT strVar = VARIANT(SysAllocString("Hello, World!"));
      hr = list.Add(strVar, index);

      if (hr == S_OK) {
        int count;
        hr = collection.Count(count);
        if (hr == S_OK)
          wprintf("collection.Count\n\t=> %d\n\n", count);

        VARIANT v;
        hr = list.get_Item(index, v);
        if (hr == S_OK)
          wprintf("list[%i]\n\t=> %s\n\n", index, v.bstrVal);
      }

      // Don't forget to free the string
      SysFreeString(strVar.bstrVal);

      list.Release();
    }

    arrayList.Release();
  }

  CoUninitialize();
  return 0;
}