
// Not compatible with std.c.windows.com

module cirrus.c.windows.com;

pragma(lib, "ole32.lib");
pragma(lib, "oleaut32.lib");

extern(Windows):

enum /* HRESULT */ {
  S_OK = 0x00000000,
  S_FALSE = 0x00000001
}

enum VARTYPE : ushort {
  VT_EMPTY = 0,
  VT_NULL	= 1,                  
  VT_I2	= 2,                  
  VT_I4	= 3,                  
  VT_R4	= 4,                  
  VT_R8	= 5,                  
  VT_CY	= 6,                  
  VT_DATE	= 7,                  
  VT_BSTR	= 8,                  
  VT_DISPATCH	= 9,              
  VT_ERROR	= 10,             
  VT_BOOL	= 11,                 
  VT_VARIANT	= 12,             
  VT_UNKNOWN	= 13,             
  VT_DECIMAL	= 14,             
  VT_I1	= 16,                 
  VT_UI1	= 17,                 
  VT_UI2	= 18,                 
  VT_UI4	= 19,                 
  VT_I8	= 20,                 
  VT_UI8	= 21,                 
  VT_INT	= 22,                 
  VT_UINT	= 23,                 
  VT_VOID	= 24,                 
  VT_HRESULT	= 25,             
  VT_PTR	= 26,                 
  VT_SAFEARRAY	= 27,         
  VT_CARRAY	= 28,             
  VT_USERDEFINED	= 29,         
  VT_LPSTR	= 30,             
  VT_LPWSTR	= 31,             
  VT_RECORD	= 36,             
  VT_INT_PTR	= 37,             
  VT_UINT_PTR	= 38,             
  VT_FILETIME	= 64,             
  VT_BLOB	= 65,                 
  VT_STREAM	= 66,             
  VT_STORAGE	= 67,             
  VT_STREAMED_OBJECT	= 68,     
  VT_STORED_OBJECT	= 69,     
  VT_BLOB_OBJECT	= 70,         
  VT_CF	= 71,                 
  VT_CLSID	= 72,             
  VT_VERSIONED_STREAM	= 73,     
  VT_BSTR_BLOB	= 0xfff,      
  VT_VECTOR	= 0x1000,         
  VT_ARRAY	= 0x2000,         
  VT_BYREF	= 0x4000,         
  VT_RESERVED	= 0x8000,         
  VT_ILLEGAL	= 0xffff,         
  VT_ILLEGALMASKED	= 0xfff,  
  VT_TYPEMASK	= 0xfff           
}

enum TYPEKIND {
  TKIND_ENUM,
  TKIND_RECORD,
  TKIND_MODULE,
  TKIND_INTERFACE,
  TKIND_DISPATCH,
  TKIND_COCLASS,
  TKIND_ALIAS,
  TKIND_UNION,
  TKIND_MAX
}

enum CALLCONV {
  CC_FASTCALL,
  CC_CDECL,
  CC_MSCPASCAL,
  CC_PASCAL = CC_MSCPASCAL,
  CC_MACPASCAL,
  CC_STDCALL,
  CC_FPFASTCALL,
  CC_SYSCALL,
  CC_MPWCDECL,
  CC_MPWPASCAL,
  CC_MAX
}

enum FUNCKIND {
  FUNC_VIRTUAL,
  FUNC_PUREVIRTUAL,
  FUNC_NONVIRTUAL,
  FUNC_STATIC,
  FUNC_DISPATCH
}

enum INVOKEKIND {
  INVOKE_FUNC = 1,
  INVOKE_PROPERTYGET = 2,
  INVOKE_PROPERTYPUT = 4,
  INVOKE_PROPERTYPUTREF = 8
}

enum SYSKIND {
  SYS_WIN16,
  SYS_WIN32,
  SYS_MAC,
  SYS_WIN64
}

enum DESCKIND {
  DESCKIND_NONE,
  DESCKIND_FUNCDESC,
  DESCKIND_VARDESC,
  DESCKIND_TYPECOMP,
  DESCKIND_IMPLICITAPPOBJ,
  DESCKIND_MAX
}

enum VARKIND {
  VAR_PERINSTANCE,
  VAR_STATIC,
  VAR_CONST,
  VAR_DISPATCH
}

enum : uint {
  CLSCTX_INPROC_SERVER = 0x1,
  CLSCTX_INPROC_HANDLER = 0x2,
  CLSCTX_LOCAL_SERVER = 0x4,
  CLSCTX_INPROC_SERVER16 = 0x8,
  CLSCTX_REMOTE_SERVER = 0x10,
  CLSCTX_INPROC_HANDLER16 = 0x20,
  CLSCTX_RESERVED1 = 0x40,
  CLSCTX_RESERVED2 = 0x80,
  CLSCTX_RESERVED3 = 0x100,
  CLSCTX_RESERVED4 = 0x200,
  CLSCTX_NO_CODE_DOWNLOAD = 0x400,
  CLSCTX_RESERVED5 = 0x800,
  CLSCTX_NO_CUSTOM_MARSHAL = 0x1000,
  CLSCTX_ENABLE_CODE_DOWNLOAD = 0x2000,
  CLSCTX_NO_FAILURE_LOG = 0x4000,
  CLSCTX_DISABLE_AAA = 0x8000,
  CLSCTX_ENABLE_AAA = 0x10000,
  CLSCTX_FROM_DEFAULT_CONTEXT = 0x20000,
  CLSCTX_ACTIVATE_32_BIT_SERVER = 0x40000,
  CLSCTX_ACTIVATE_64_BIT_SERVER = 0x80000
}

// Differs from the PSDK version for easier GUID definitions
struct GUID {
  align(1):
  uint a;
  ushort b, c;
  ubyte d, e, f, g, h, i, j, k;
}

struct VARIANT {

  const short TRUE = -1;
  const short FALSE = 0;

  static VARIANT opCall(wchar* value) {
    VARIANT var;
    var.vt = VARTYPE.VT_BSTR;
    var.bstrVal = value;
    return var;
  }

  static VARIANT opCall(int value) {
    VARIANT var;
    var.vt = VARTYPE.VT_I4;
    var.lVal = value;
    return var;
  }

  static VARIANT opCall(uint value) {
    VARIANT var;
    var.vt = VARTYPE.VT_UI4;
    var.ulVal = value;
    return var;
  }

  union {
    struct {
      VARTYPE vt;
      ushort wReserved1;
      ushort wReserved2;
      ushort wReserved3;
      union {
        long llVal;
        int lVal;
        ubyte bVal;
        short iVal;
        float fltVal;
        double dblVal;
        short boolVal;
        int scode;
        long cyVal;
        double date;
        wchar* bstrVal;
        IUnknown punkVal;
        IDispatch pdispVal;
        SAFEARRAY* parray;
        ubyte* pbVal;
        short* piVal;
        int* plVal;
        long* pllVal;
        float* pfltVal;
        double* pdblVal;
        short* pboolVal;
        int* pscode;
        long* pcyVal;
        double* pdate;
        wchar** pbstrVal;
        IUnknown* ppunkVal;
        IDispatch* ppdispVal;
        SAFEARRAY** pparray;
        VARIANT* pvarVal;
        void* byref;
        char cVal;
        ushort uiVal;
        uint ulVal;
        ulong ullVal;
        int intVal;
        uint uintVal;
        DECIMAL* pdecVal;
        char* pcVal;
        ushort* puiVal;
        uint* pulVal;
        ulong* pullVal;
        int* pintVal;
        uint* puintVal;
        struct {
          void* pvRecord;
          IRecordInfo pRecInfo;
        }
      }
    }
    DECIMAL decVal;
  }
}

struct DECIMAL {
  ushort wReserved;
  union {
    struct {
      ubyte scale;
      ubyte sign;
    }
    ushort signscale;
  }
  uint Hi32;
  union {
    struct {
      uint Lo32;
      uint Mid32;
    }
  }
  ulong Lo64;
}

struct SAFEARRAYBOUND {
  uint cElements;
  int lLbound;
}

struct SAFEARRAY {
  ushort cDims;
  ushort fFeatures;
  uint cbElements;
  uint cLocks;
  void* pvData;
  SAFEARRAYBOUND[] rgsabound;
}

struct EXCEPINFO {
  ushort wCode;
  ushort wReserved;
  wchar* bstrSource;
  wchar* bstrDescription;
  wchar* bstrHelpFile;
  uint dwHelpContext;
  void* pvReserved;
  int function(EXCEPINFO*) pfnDeferredFillIn;
  int scode;
}

struct DISPPARAMS {
  VARIANT* rgvarg;
  int* rgdispidNamedArgs;
  uint cArgs;
  uint cNamedArgs;
}

struct TYPEDESC {
  union {
    TYPEDESC* lptdesc;
    ARRAYDESC* lpadesc;
    uint hreftype;
  }
  VARTYPE vt;
}

struct FUNCDESC {
  int memid;
  int* lprgscode;
  ELEMDESC* lprgelemdescParam;
  FUNCKIND funckind;
  INVOKEKIND invkind;
  CALLCONV callconv;
  short cParams;
  short cParamsOpt;
  short oVft;
  short cScodes;
  ELEMDESC elemdescFunc;
  ushort wFuncFlags;
}

struct VARDESC {
  int memid;
  wchar* lpstrSchema;
  union {
    uint oInst;
    VARIANT* lpvasrValue;
  }
  ELEMDESC elemdescVar;
  ushort wVarFlags;
  VARKIND vakind;
}

struct PARAMDESC {
  uint cBytes;
  VARIANT varDefaultValue;
}

struct ELEMDESC {
  TYPEDESC tdesc;
  union {
    IDLDESC idldesc;
    PARAMDESC paramdesc;
  }
}

struct ARRAYDESC {
  TYPEDESC tdescElem;
  ushort cDims;
  SAFEARRAYBOUND[1] rgBounds;
}

struct IDLDESC {
  uint dwReserved;
  ushort wIDLFlags;
}

struct TYPEATTR {
  GUID guid;
  uint lcid;
  uint dwReserved;
  int memidConstructor;
  int memidDestructor;
  wchar* lpstrSchema;
  uint cbSizeInstance;
  TYPEKIND typekind;
  ushort cFuncs;
  ushort cVars;
  ushort cImplTypes;
  ushort cbSizeVft;
  ushort cbAlignment;
  ushort wTypeFlags;
  ushort wMajorVerNum;
  ushort wMinorVerNum;
  TYPEDESC tdescAlias;
  IDLDESC idldescType;
}

struct TLIBATTR {
  GUID guid;
  uint lcid;
  SYSKIND syskind;
  ushort wMajorVerNum;
  ushort wMinorVerNum;
}

struct BINDPTR {
  FUNCDESC* lpfuncdesc;
  VARDESC* lpvardesc;
  ITypeComp lptcomp;
}

// Not an official COM interface, just used for template default parameters
interface INull {
  static GUID IID = { 0x00000000, 0x0000, 0x0000, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
}

interface IUnknown {
  static GUID IID = { 0x00000000, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int QueryInterface(inout GUID riid, void** ppvObject);
  uint AddRef();
  uint Release();
}

interface IRecordInfo : IUnknown {
  static GUID IID = { 0x0000002f, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RecordInit(void* pvNew);
  int RecordClear(void* pvExisting);
  int RecordCopy(void* pvExisting, void* pvNew);
  int GetGuid(out GUID pguid);
  int GetName(out wchar* pbstrName);
  int GetSize(out uint pcbSize);
  int GetTypeInfo(out ITypeInfo ppTypeInfo);
  int GetField(void* pvData, wchar* szFieldName, out VARIANT pvarField);
  int GetFieldNoCopy(void* pvData, wchar* szFieldName, out VARIANT pvarField, void** ppvDataCArray);
  int PutField(uint wFlags, void* pvData, wchar* szFieldName, inout VARIANT pvarField);
  int PutFieldNoCopy(uint wFlags, void* pvData, wchar* szFieldName, inout VARIANT pvarField);
  int GetFieldNames(out uint pcNames, wchar** rgBstrNames);
  bool IsMatchingType(IRecordInfo pRecordInfo);
  void* RecordCreate();
  int RecordCreateCopy(void* pvSource, out void* ppvDest);
  int RecordDestroy(void* pvRecord);
}

interface IDispatch : IUnknown {
  static GUID IID = { 0x00020400, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int GetTypeInfoCount(out uint pctinfo);
  int GetTypeInfo(uint iTInfo, uint lcid, out ITypeInfo ppTInfo);
  int GetIDsOfNames(inout GUID riid, wchar** rgszNames, uint cNames, uint lcid, out int rgDispId);
  int Invoke(int dispMember, inout GUID riid, uint lcid, ushort wFlags, inout DISPPARAMS pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, uint* puArgError);
}

interface ITypeInfo : IUnknown {
  static GUID IID = { 0x00020401, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int GetTypeAttr(out TYPEATTR* ppTypeAttr);
  int GetTypeComp(out ITypeComp ppTComp);
  int GetFuncDesc(uint index, out FUNCDESC* ppFuncDesc);
  int GetVarDesc(uint index, out VARDESC* ppVarDesc);
  int GetNames(int memid, wchar** rgBstrNames, uint cMaxNames, out uint pcNames);
  int GetRefTypeOfImplType(uint index, out uint pRefType);
  int GetImplTypeFlags(uint index, out int pImplTypeFlags);
  int GetIDsOfNames(wchar** rgszNames, uint cNames, int* pMemId);
  int Invoke(void* pvInstance, int memid, ushort wFlags, inout DISPPARAMS pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, uint* puArgError);
  int GetDocumentation(int memid, out wchar* pBstrName, out wchar* pBstrDocName, out uint pdwHelpContext, out wchar* pBstrHelpFile);
  int GetDllEntry(int memid, INVOKEKIND invKind, out wchar* pBstrDllName, out wchar* pBstrName, out ushort pwOrdinal);
  int GetRefTypeInfo(uint hRefType, out ITypeInfo ppTInfo);
  int AddressOfMember(int memid, INVOKEKIND invKind, out void* ppvObj);
  int CreateInstance(IUnknown pUnkOuter, inout GUID riid, void** ppvObj);
  int GetMops(int memid, out wchar* pBstrMops);
  int GetContainingTypeLib(out ITypeLib ppTLib, out uint pIndex);
  int ReleaseTypeAttr(TYPEATTR* pTypeAttr);
  int ReleaseFuncDesc(FUNCDESC* pFuncDesc);
  int ReleaseVarDesc(VARDESC* pVarDesc);
}

interface ITypeLib : IUnknown {
  static GUID IID = { 0x00020402, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  uint GetTypeInfoCount();
  int GetTypeInfo(uint index, out ITypeInfo ppTInfo);
  int GetTypeInfoType(uint index, out TYPEKIND pTKind);
  int GetTypeInfoOfGuid(inout GUID guid, out ITypeInfo ppTInfo);
  int GetLibAttr(out TLIBATTR* ppTLibAttr);
  int GetTypeComp(out ITypeComp ppTComp);
  int GetDocumentation(int index, out wchar* pBstrName, out wchar* pBstrDocString, out uint pdwHelpContext, out wchar* pBstrHelpFile);
  int IsName(wchar* szNameBuf, uint lHashVal, out bool pfName);
  int FindName(wchar* szNameBuf, uint lHashVal, ITypeInfo* ppTInfo, int rgMemId);
  int ReleaseTLibAttr(TLIBATTR* pTLibAttr);
}

interface ITypeComp : IUnknown {
  static GUID IID = { 0x00020403, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int Bind(wchar* szName, uint lHashVal, ushort wFlags, out ITypeInfo ppTInfo, out DESCKIND pDescKind, out BINDPTR pBindPtr);
  int BindType(wchar* szName, uint lHashVal, out ITypeInfo ppTInfo, out ITypeComp ppTComp);
}

int CoInitialize(void* pvReserved);
void CoUninitialize();
int OleInitialize(void* pvReserved);
void OleUninitialize();

int CoCreateInstance(inout GUID rclsid, IUnknown pUnkOuter, uint dwClsContext, inout GUID rrid, void** ppv);

wchar* SysAllocString(wchar*);
wchar* SysAllocStringLen(wchar*, uint);
void SysFreeString(wchar*);

SAFEARRAY* SafeArrayCreate(VARTYPE vt, uint cDims, SAFEARRAYBOUND* rgsabound);
SAFEARRAY* SafeArrayCreateVector(VARTYPE vt, int lLbound, uint cElements);
int SafeArrayDestroy(SAFEARRAY* psa);
int SafeArrayAccessData(SAFEARRAY* psa, void** ppvData);
int SafeArrayGetUBound(SAFEARRAY* psa, uint nDim, out int plUbound);
int SafeArrayGetLBound(SAFEARRAY* psa, uint nDim, out int plLbound);
uint SafeArrayGetDim(SAFEARRAY* psa);
int SafeArrayGetElement(SAFEARRAY* psa, int* rgIndices, void* pv);
int SafeArrayPutElement(SAFEARRAY* psa, int* rgIndices, void* pv);
int SafeArrayLock(SAFEARRAY* psa);
int SafeArrayUnlock(SAFEARRAY* psa);

// Helpers

template CoClass(I0, I1 = INull, I2 = INull, I3 = INull, I4 = INull, I5 = INull, I6 = INull, I7 = INull, I8 = INull, I9 = INull) {
  template createObject(T) {
    static T createObject() {
      static if (is(T == I0) || is (T == I1) || is (T == I2) || is (T == I3) || is (T == I4) || is (T == I5) || is (T == I6) || is (T == I7) || is (T == I8) || is (T == I9)) {
        T ret = null;
        int hr = CoCreateInstance(IID, null, CLSCTX_INPROC_SERVER, T.IID, cast(void**)&ret);
        return (hr == S_OK) ? ret : null;
      }
      else {
        pragma(msg, "T is not valid for createObject.");
        return null;
      }
    }
  }
}

template com_cast(R, I = IUnknown) {
  R com_cast(I pUnk) {
    if (pUnk is null)
      return null;

    R ret = null;
    int hr = pUnk.QueryInterface(R.IID, cast(void**)&ret);

    return (hr == S_OK) ? ret : null;
  }
}